<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Inventory_gold extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('inv_gold_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->inv_gold_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'New Gold/Silver';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_inventory_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '3');
        $this->render($data, 'inv_gold/list');
    }
    
    private function get_gold_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->inv_gold_model->gold_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_gold_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['gold_types'] = $this->inv_gold_model->gold_type_list();
        $data['form_action'] = $actions['insert'];
        $this->render($data, 'inv_gold/add');
    }
    
    public function add_new_type() {
        $data =  $this->inv_gold_model->add_new_type($_POST['type'],$this->user_data['user_id']);
        echo json_encode($data);
        exit(0);
    }
    
    public function insert() {
        $insert = array(
            /* 'name' => $this->input->post('name'),
            'contact_no' => $this->input->post('contact_no'),
            'address' => $this->input->post('address'), */
            'type' => $this->input->post('type_id'),
            'item' => $this->input->post('item'),
            'description' => $this->input->post('desc'),
            'weight' => $this->input->post('weight_in_grams'),
            'url_key' => $this->get_gold_url_key($this->input->post('name')),
            #'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->inv_gold_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Gold/Silver details added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Gold/Silver details not added!');
        redirect('inventory_gold', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['gold_types'] = $this->inv_gold_model->gold_type_list();
        $data['gold'] = $this->inv_gold_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'inv_gold/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            /* 'name' => $this->input->post('name'),
            'contact_no' => $this->input->post('contact_no'),
            'address' => $this->input->post('address'), */
            'type' => $this->input->post('type_id'),
            'item' => $this->input->post('item'),
            'description' => $this->input->post('desc'),
            'weight' => $this->input->post('weight_in_grams'),
            'url_key' => $this->get_gold_url_key($this->input->post('name')),
            #'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        
        if ( $this->inv_gold_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Gold/Silver details updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Gold/Silver details not updated!');    
        
        redirect('inventory_gold','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['gold'] = $this->inv_gold_model->get_by_id($id);
        $this->render($data, 'inv_gold/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->inv_gold_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Gold/Silver details deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Gold/Silver details not deleted!');
        
        redirect( 'inventory_gold', 'refresh');
    }
    
    public function check_type_exists(){
        $data = $this->inv_gold_model->check_type_exists($_POST['type']);
        echo json_encode($data);
        exit(0);
    }
}
?>